<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMoradasAlternativasClientesERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMoradasAlternativasClientesERP
 * @subpackage Arrays
 */
class ArrayOfMoradasAlternativasClientesERP extends AbstractStructArrayBase
{
    /**
     * The MoradasAlternativasClientesERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MoradasAlternativasClientesERP[]
     */
    public $MoradasAlternativasClientesERP;
    /**
     * Constructor method for ArrayOfMoradasAlternativasClientesERP
     * @uses ArrayOfMoradasAlternativasClientesERP::setMoradasAlternativasClientesERP()
     * @param \StructType\MoradasAlternativasClientesERP[] $moradasAlternativasClientesERP
     */
    public function __construct(array $moradasAlternativasClientesERP = array())
    {
        $this
            ->setMoradasAlternativasClientesERP($moradasAlternativasClientesERP);
    }
    /**
     * Get MoradasAlternativasClientesERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MoradasAlternativasClientesERP[]|null
     */
    public function getMoradasAlternativasClientesERP()
    {
        return isset($this->MoradasAlternativasClientesERP) ? $this->MoradasAlternativasClientesERP : null;
    }
    /**
     * Set MoradasAlternativasClientesERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MoradasAlternativasClientesERP[] $moradasAlternativasClientesERP
     * @return \ArrayType\ArrayOfMoradasAlternativasClientesERP
     */
    public function setMoradasAlternativasClientesERP(array $moradasAlternativasClientesERP = array())
    {
        foreach ($moradasAlternativasClientesERP as $arrayOfMoradasAlternativasClientesERPMoradasAlternativasClientesERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfMoradasAlternativasClientesERPMoradasAlternativasClientesERPItem instanceof \StructType\MoradasAlternativasClientesERP) {
                throw new \InvalidArgumentException(sprintf('The MoradasAlternativasClientesERP property can only contain items of \StructType\MoradasAlternativasClientesERP, "%s" given', is_object($arrayOfMoradasAlternativasClientesERPMoradasAlternativasClientesERPItem) ? get_class($arrayOfMoradasAlternativasClientesERPMoradasAlternativasClientesERPItem) : gettype($arrayOfMoradasAlternativasClientesERPMoradasAlternativasClientesERPItem)), __LINE__);
            }
        }
        if (is_null($moradasAlternativasClientesERP) || (is_array($moradasAlternativasClientesERP) && empty($moradasAlternativasClientesERP))) {
            unset($this->MoradasAlternativasClientesERP);
        } else {
            $this->MoradasAlternativasClientesERP = $moradasAlternativasClientesERP;
        }
        return $this;
    }
    /**
     * Add item to MoradasAlternativasClientesERP value
     * @throws \InvalidArgumentException
     * @param \StructType\MoradasAlternativasClientesERP $item
     * @return \ArrayType\ArrayOfMoradasAlternativasClientesERP
     */
    public function addToMoradasAlternativasClientesERP(\StructType\MoradasAlternativasClientesERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MoradasAlternativasClientesERP) {
            throw new \InvalidArgumentException(sprintf('The MoradasAlternativasClientesERP property can only contain items of \StructType\MoradasAlternativasClientesERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MoradasAlternativasClientesERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MoradasAlternativasClientesERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MoradasAlternativasClientesERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MoradasAlternativasClientesERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MoradasAlternativasClientesERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MoradasAlternativasClientesERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MoradasAlternativasClientesERP
     */
    public function getAttributeName()
    {
        return 'MoradasAlternativasClientesERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMoradasAlternativasClientesERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
